> For the complete documentation index, see [llms.txt](https://doc.batch.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://doc.batch.com/developer/sdk/web/profile-data/topic-preferences.md).

# Topic preferences

The Batch Web SDK allows you to:

* Add or remove topic preferences from a user profile (the profile is created automatically if it doesn’t already exist).
* Partially update topic preferences within a user profile.

> Requires SDK 4.3+

Here’s how to update topic preferences:

{% tabs %}
{% tab title="JavaScript (ES8)" %}

```javascript
batchSDK(async api => {
    const profile = await api.profile();
    await profile.edit(editor => {
      editor.setTopicPreferences(["technology", "finance"]) // null to erase
      // Alternatively, partially update them with:
      editor.addToTopicPreferences(["investing"])
      editor.removeFromTopicPreferences(["travel"])
    })
});
```

{% endtab %}

{% tab title="JavaScript" %}

<pre class="language-javascript"><code class="lang-javascript">batchSDK(api => {
    api.profile().then(profile => {
<strong>      profile.edit(editor => {
</strong>          editor.setTopicPreferences(["technology", "finance"]) // null to erase
          // Alternatively, partially update them with:
          editor.addToTopicPreferences(["investing"])
          editor.removeFromTopicPreferences(["travel"])
      })
    })
});
</code></pre>

{% endtab %}
{% endtabs %}

{% hint style="info" %}
**Note**: Topics must be a valid List of String not longer than 25 items. String should be made of letters, numbers or underscores (\[a-z0-9\_]) and can't be longer than 300 characters.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://doc.batch.com/developer/sdk/web/profile-data/topic-preferences.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
